#include <iostream> // Pour affiher le résultat
#include <random> // Pour simuler des variables aléatoire
#include <cmath> // Pour la fonction sqrt

int const N = 100; // Le nombre de pas de discrétisation en temps.
double const dt = 1./N; // Le pas de temps
int const MC = 100000;

// Une fonction qui renvoie (une approximation de) p(W0), à laquelle on fournit également en argument  générateur aléatoire
double P(double W0, std::mt19937& G)
{
  std::normal_distribution<double> X(0,1);

  int compte = 0;// On compte le nombre de trajectoires qui restent dans ]0,1[
  for (int k=0; k<MC; k++)
	{
	  double W = W0;// On part de W0
	  int i=0;
	  while (W>0 and W<1 and i<N)// On fait tourner la simulation jusqu'à t=1, ou bien dès que la trajectoire quitte ]0,1[
		{
		  W += sqrt(dt)*X(G);
		  i++;
		}

	  if (i==N)// Si le temps est allé jusqu'au bout, c'est que la trajectoire n'a pas quitté l'intervalle ]0,1[
		compte += 1;
	}
  return compte/(double)MC;
}



int main(void)
{
  std::mt19937 G(36297);

  for (double W0=0.1; W0<0.6; W0+=0.2)//On renvoie la valeur pour 0.1, 0.3 et 0.5
	std::cout << "p(" << W0 << ") = " << P(W0,G) << "\n";
  
  return 0;
}
